/* $Id: hash.h 254 2002-09-13 14:31:38Z clerger $
 * Copyright (C) 1997 Eric de la Clergerie
 * ------------------------------------------------------------
 *
 *   Hash --
 *
 * ------------------------------------------------------------
 * Description
 *
 * ------------------------------------------------------------
 */

typedef struct {
    char *current;
} HashScan;

extern char *Hash_Alloc_Table(const int tbl_size,const int elem_size);
extern void Hash_Free_Table(char *tbl);
extern char *Hash_Insert(const char *tbl,const char *elem,const int replace);
extern char *Hash_Find(const char *tbl, const long key);
extern void Hash_Delete(const char *tbl, const long key);
extern char *Hash_First(const char *tbl, HashScan *scan);
extern char *Hash_Next(HashScan *scan);
extern int Hash_Table_Size(const char *tbl);
extern int Hash_Nb_Elements(const char *tbl);


